C Computes the 1-SQRT(x) with full precision
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------

      double precision function omsqrtom(x)
      implicit none
      integer*4 i, ilimit
      double precision x,omsqrtom_series
      double precision dlimitconv,num,den,alpha,result
C 47 are the required iterations to provide the right convergence in
C quadruple precision for .le. 0.2
      parameter (dlimitconv=0.2d0, ilimit=48)
      data alpha/0.5d0/
C Strategy: If direct computation of 1-SQRT(1-x) looses more than one digit

      num=1d0
      den=1d0
      result=0d0

      if (ABS(x).lt.dlimitconv) then
C     We do series
      do i=1,ilimit
         num=num*(alpha+1-i)*(-x)
         result=result+num/den
c         print *,'res-ser=',i,result,omsqrtom_series,num,den
         if (result.NE.omsqrtom_series) then
            omsqrtom_series=result
            den=den*(i+1)
         else
c            print *,'i=',i
            omsqrtom=-omsqrtom_series
            goto 10
         endif
      enddo
      else
         omsqrtom=1-SQRT(1-x)
      endif
 10   continue
      return
      end

c      program test
c      implicit none
c      integer i,ilimit
c      parameter (ilimit=40)
c      double precision y(ilimit),sy(ilimit)
c      double precision omsqrtom
cc      external omsqrtom
c
c      do i=0,ilimit
c         y(i)=0.4d0/(2d0**i)
c         sy(i)=omsqrtom(y(i))
c         print 10,'omsqrtom(y(',i,')=',y(i),')=',sy(i)
c      enddo
c 10   format (A12,i2,A2,E21.15,A2,1X,E39.33,1X,E39.33)
c      end
